diff --git a/django/views/generic/simple.py b/django/views/generic/simple.py
index 3b5309d..435cd76 100644
--- a/django/views/generic/simple.py
+++ b/django/views/generic/simple.py
@@ -17,7 +17,7 @@ def direct_to_template(request, template, extra_context=None, mimetype=None, **k
     t = loader.get_template(template)
     return HttpResponse(t.render(c), mimetype=mimetype)
 
-def redirect_to(request, url, permanent=True, **kwargs):
+def redirect_to(request, url, permanent=True, query_string=False, **kwargs):
     """
     Redirect to a given URL.
 
@@ -33,7 +33,15 @@ def redirect_to(request, url, permanent=True, **kwargs):
 
     If the ``permanent`` argument is False, then the response will have a 302
     HTTP status code. Otherwise, the status code will be 301.
+
+    If the ``query_string`` argument is True, then the GET query string
+    from the request is appended to the URL.
+
     """
+    args = request.META["QUERY_STRING"]
+    if args and query_string and url is not None:
+        url = "%s?%s" % (url, args)
+
     if url is not None:
         klass = permanent and HttpResponsePermanentRedirect or HttpResponseRedirect
         return klass(url % kwargs)
diff --git a/docs/ref/generic-views.txt b/docs/ref/generic-views.txt
index 427ef91..5e8b442 100644
--- a/docs/ref/generic-views.txt
+++ b/docs/ref/generic-views.txt
@@ -139,9 +139,15 @@ If the given URL is ``None``, Django will return an ``HttpResponseGone`` (410).
       redirect will use status code 301. If ``False``, then the redirect will
       use status code 302. By default, ``permanent`` is ``True``.
 
+    * ``query_string``: Whether to pass along the GET query string to
+      the new location. If ``True``, then the query string is appended
+      to the URL. If ``False``, then the query string is discarded. By
+      default, ``query_string`` is ``False``.
+
 .. versionadded:: 1.1
     The ``permanent`` keyword argument is new in Django 1.1.
 
+
 **Example:**
 
 This example issues a permanent redirect (HTTP status code 301) from
diff --git a/tests/regressiontests/views/tests/__init__.py b/tests/regressiontests/views/tests/__init__.py
index 9964cd5..12863ae 100644
--- a/tests/regressiontests/views/tests/__init__.py
+++ b/tests/regressiontests/views/tests/__init__.py
@@ -3,3 +3,5 @@ from i18n import *
 from static import *
 from generic.date_based import *
 from generic.create_update import *
+from generic.simple import *
+
diff --git a/tests/regressiontests/views/tests/generic/simple.py b/tests/regressiontests/views/tests/generic/simple.py
new file mode 100644
index 0000000..f94b3da
--- /dev/null
+++ b/tests/regressiontests/views/tests/generic/simple.py
@@ -0,0 +1,38 @@
+# coding: utf-8
+
+from django.test import TestCase
+
+class RedirectToTest(TestCase):
+    def test_redirect_to_returns_permanent_redirect(self):
+        "simple.redirect_to returns a permanent redirect (301) by default"
+        response = self.client.get('/views/simple/redirect_to/')
+        self.assertEqual(response.status_code, 301)
+        self.assertEqual('http://testserver/views/simple/target/', response['Location'])
+
+    def test_redirect_to_can_return_a_temporary_redirect(self):
+        "simple.redirect_to returns a temporary redirect (302) when explicitely asked to"
+        response = self.client.get('/views/simple/redirect_to_temp/')
+        self.assertEqual(response.status_code, 302)
+        self.assertEqual('http://testserver/views/simple/target/', response['Location'])
+
+    def test_redirect_to_on_empty_url_returns_gone(self):
+        "simple.redirect_to returns resource gone (410) when given a None url"
+        response = self.client.get('/views/simple/redirect_to_none/')
+        self.assertEqual(response.status_code, 410)
+
+    def test_redirect_to_allows_formatted_url_string(self):
+        "simple.redirect_to uses string interpolation on target url for keyword args"
+        response = self.client.get('/views/simple/redirect_to_arg/42/')
+        self.assertEqual(response.status_code, 301)
+        self.assertEqual('http://testserver/views/simple/target_arg/42/', response['Location'])
+
+    def test_redirect_to_allows_query_string_to_be_passed(self):
+        "simple.redirect_to configured with query_string=True passes on any query string"
+        # the default is to not forward the query string
+        response = self.client.get('/views/simple/redirect_to/?param1=foo&param2=bar')
+        self.assertEqual(response.status_code, 301)
+        self.assertEqual('http://testserver/views/simple/target/', response['Location'])
+        # views configured with query_string=True however passes the query string along
+        response = self.client.get('/views/simple/redirect_to_query/?param1=foo&param2=bar')
+        self.assertEqual(response.status_code, 301)
+        self.assertEqual('http://testserver/views/simple/target/?param1=foo&param2=bar', response['Location'])
diff --git a/tests/regressiontests/views/urls.py b/tests/regressiontests/views/urls.py
index 6403ab3..d7779f7 100644
--- a/tests/regressiontests/views/urls.py
+++ b/tests/regressiontests/views/urls.py
@@ -82,3 +82,13 @@ urlpatterns += patterns('django.views.generic.create_update',
     (r'^create_update/no_url/update/article/(?P<slug>[-\w]+)/$',
         'update_object', dict(slug_field='slug', model=UrlArticle)),
 )
+
+# simple generic views.
+
+urlpatterns += patterns('django.views.generic.simple',
+    (r'^simple/redirect_to/$', 'redirect_to', dict(url='/views/simple/target/')),
+    (r'^simple/redirect_to_temp/$', 'redirect_to', dict(url='/views/simple/target/', permanent=False)),
+    (r'^simple/redirect_to_none/$', 'redirect_to', dict(url=None)),
+    (r'^simple/redirect_to_arg/(?P<id>\d+)/$', 'redirect_to', dict(url='/views/simple/target_arg/%(id)s/')),
+    (r'^simple/redirect_to_query/$', 'redirect_to', dict(url='/views/simple/target/', query_string=True)),
+)