diff -r 3976471d3430 django/contrib/admin/filterspecs.py
--- a/django/contrib/admin/filterspecs.py	Wed Feb 25 21:56:00 2009 -0200
+++ b/django/contrib/admin/filterspecs.py	Thu Feb 26 13:39:24 2009 -0200
@@ -89,7 +89,7 @@
         yield {'selected': self.lookup_val is None,
                'query_string': cl.get_query_string({}, [self.lookup_kwarg]),
                'display': _('All')}
-        for k, v in self.field.choices:
+        for k, v in self.field.flatchoices:
             yield {'selected': smart_unicode(k) == self.lookup_val,
                     'query_string': cl.get_query_string({self.lookup_kwarg: k}),
                     'display': v}
diff -r 3976471d3430 django/contrib/admin/templatetags/admin_list.py
--- a/django/contrib/admin/templatetags/admin_list.py	Wed Feb 25 21:56:00 2009 -0200
+++ b/django/contrib/admin/templatetags/admin_list.py	Thu Feb 26 13:39:24 2009 -0200
@@ -205,8 +205,8 @@
                     result_repr = EMPTY_CHANGELIST_VALUE
             # Fields with choices are special: Use the representation
             # of the choice.
-            elif f.choices:
-                result_repr = dict(f.choices).get(field_val, EMPTY_CHANGELIST_VALUE)
+            elif f.flatchoices:
+                result_repr = dict(f.flatchoices).get(field_val, EMPTY_CHANGELIST_VALUE)
             else:
                 result_repr = escape(field_val)
         if force_unicode(result_repr) == '':
diff -r 3976471d3430 tests/regressiontests/admin_views/customadmin.py
--- a/tests/regressiontests/admin_views/customadmin.py	Wed Feb 25 21:56:00 2009 -0200
+++ b/tests/regressiontests/admin_views/customadmin.py	Thu Feb 26 13:39:24 2009 -0200
@@ -28,3 +28,4 @@
 site.register(models.Article, models.ArticleAdmin)
 site.register(models.Section, inlines=[models.ArticleInline])
 site.register(models.Thing, models.ThingAdmin)
+site.register(models.Fabric, models.FabricAdmin)
diff -r 3976471d3430 tests/regressiontests/admin_views/fixtures/admin-views-fabrics.xml
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/regressiontests/admin_views/fixtures/admin-views-fabrics.xml	Thu Feb 26 13:39:24 2009 -0200
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="utf-8"?>
+<django-objects version="1.0">
+  <object pk="1" model="admin_views.fabric">
+    <field type="CharField" name="surface">x</field>
+  </object>
+  <object pk="2" model="admin_views.fabric">
+    <field type="CharField" name="surface">y</field>
+  </object>
+  <object pk="3" model="admin_views.fabric">
+    <field type="CharField" name="surface">plain</field>
+  </object>
+</django-objects>
diff -r 3976471d3430 tests/regressiontests/admin_views/models.py
--- a/tests/regressiontests/admin_views/models.py	Wed Feb 25 21:56:00 2009 -0200
+++ b/tests/regressiontests/admin_views/models.py	Thu Feb 26 13:39:24 2009 -0200
@@ -134,12 +134,28 @@
 class ThingAdmin(admin.ModelAdmin):
     list_filter = ('color',)
 
+class Fabric(models.Model):
+    NG_CHOICES = (
+        ('Textured', (
+                ('x', 'Horizontal'),
+                ('y', 'Vertical'),
+            )
+        ),
+        ('plain', 'Smooth'),
+    )
+    surface = models.CharField(max_length=20, choices=NG_CHOICES)
+
+class FabricAdmin(admin.ModelAdmin):
+    list_display = ('surface',)
+    list_filter = ('surface',)
+
 admin.site.register(Article, ArticleAdmin)
 admin.site.register(CustomArticle, CustomArticleAdmin)
 admin.site.register(Section, inlines=[ArticleInline])
 admin.site.register(ModelWithStringPrimaryKey)
 admin.site.register(Color)
 admin.site.register(Thing, ThingAdmin)
+admin.site.register(Fabric, FabricAdmin)
 
 # We intentionally register Promo and ChapterXtra1 but not Chapter nor ChapterXtra2.
 # That way we cover all four cases:
diff -r 3976471d3430 tests/regressiontests/admin_views/tests.py
--- a/tests/regressiontests/admin_views/tests.py	Wed Feb 25 21:56:00 2009 -0200
+++ b/tests/regressiontests/admin_views/tests.py	Thu Feb 26 13:39:24 2009 -0200
@@ -12,9 +12,9 @@
 from models import Article, CustomArticle, Section, ModelWithStringPrimaryKey
 
 class AdminViewBasicTest(TestCase):
-    fixtures = ['admin-views-users.xml', 'admin-views-colors.xml']
-    
-    # Store the bit of the URL where the admin is registered as a class 
+    fixtures = ['admin-views-users.xml', 'admin-views-colors.xml', 'admin-views-fabrics.xml']
+
+    # Store the bit of the URL where the admin is registered as a class
     # variable. That way we can test a second AdminSite just by subclassing
     # this test case and changing urlbit.
     urlbit = 'admin'
@@ -172,6 +172,37 @@
         self.assertRedirects(response, '/test_admin/%s/admin_views/thing/?e=1' % self.urlbit)        
         response = self.client.get('/test_admin/%s/admin_views/thing/' % self.urlbit, {'color__id__exact': 'StringNotInteger!'})
         self.assertRedirects(response, '/test_admin/%s/admin_views/thing/?e=1' % self.urlbit)
+
+    def testNamedGroupFieldChoicesChangeList(self):
+        """
+        Ensures the admin changelist shows correct values in the relevant column
+        for rows corresponding to instances of a model in which a named group
+        has been used in the choices option of a field.
+        """
+        response = self.client.get('/test_admin/%s/admin_views/fabric/' % self.urlbit)
+        self.failUnlessEqual(response.status_code, 200)
+        self.failUnless(
+            '<a href="1/">Horizontal</a>' in response.content and
+            '<a href="2/">Vertical</a>' in response.content,
+            "Changelist table isn't showing the right human-readable values set by a model field 'choices' option named group."
+        )
+
+    def testNamedGroupFieldChoicesFilter(self):
+        """
+        Ensures the filter UI shows correctly when at least one named group has
+        been used in the choices option of a model field.
+        """
+        response = self.client.get('/test_admin/%s/admin_views/fabric/' % self.urlbit)
+        self.failUnlessEqual(response.status_code, 200)
+        self.failUnless(
+            '<div id="changelist-filter">' in response.content,
+            "Expected filter not found in changelist view."
+        )
+        self.failUnless(
+            '<a href="?surface__exact=x">Horizontal</a>' in response.content and
+            '<a href="?surface__exact=y">Vertical</a>' in response.content,
+            "Changelist filter isn't showing options contained inside a model field 'choices' option named group."
+        )
 
 class CustomModelAdminTest(AdminViewBasicTest):
     urlbit = "admin2"